package proyecto.view;

import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.util.ArrayList;

import org.richfaces.event.UploadEvent;
import org.richfaces.model.UploadItem;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

@Component("importacionController")
@Scope("request")

public class ImportacionController {

	private ArrayList<Archivo> archivos = new ArrayList<Archivo>();

	private int uploadsDisponible = 3;
	private boolean autoUpload = false;
	private boolean useFlash = false;

	String directorio = "E:/Desarrollo";

	public int getSize (){
	
		System.out.println("paso por getsize"+getArchivos().size());
		
		if(getArchivos().size()> 0){
			return getArchivos().size();			
		}else{
			return 0;
		}	

	}
	
	public ImportacionController() {
	}

	public void paint(OutputStream stream, Object object) throws IOException{
		System.out.println("paso por paint");
		stream.write(getArchivos().get((Integer)object).getData());
	}	

	public void listener (UploadEvent event) throws Exception{
		
		System.out.println("ENTRO EN LA FUNCION");

		UploadItem item = event.getUploadItem();
		Archivo archivo = new Archivo();

		archivo.setLength(item.getData().length);
		archivo.setName(item.getFileName());
		archivo.setData(item.getData());
		archivos.add(archivo);
		uploadsDisponible --;	

		System.out.println("NOMBRE " + item.getFileName());
		System.out.println("DATA " + item.getData());
	}

	public String clearUploadData() throws Exception{
        
		System.out.println("entro en claerUploadData");
		
		for(int i=0;i < archivos.size(); i++){
			java.io.File archivo = new java.io.File(this.directorio, archivos.get(i).getName());

			FileOutputStream fileOutStream = new FileOutputStream(archivo);

			System.out.println("ARCHIVO GUARDADO " + archivos.get(i).getName());
			fileOutStream.write(archivos.get(i).getData());
			fileOutStream.flush();
			fileOutStream.close();							
		}
		archivos.clear();
		setUploadsDisponible(2);
		return null;
	}

	public long getTimeStamp(){
		return System.currentTimeMillis();
	}

	public ArrayList<Archivo> getArchivos() {
		return archivos;
	}

	public void setArchivos(ArrayList<Archivo> archivos) {
		this.archivos = archivos;
	}

	public int getUploadsDisponible() {
		return uploadsDisponible;
	}

	public void setUploadsDisponible(int uploadsDisponible) {
		this.uploadsDisponible = uploadsDisponible;
	}

	public boolean isAutoUpload() {
		return autoUpload;
	}

	public void setAutoUpload(boolean autoUpload) {
		this.autoUpload = autoUpload;
	}

	public boolean isUseFlash() {
		return useFlash;
	}

	public void setUseFlash(boolean useFlash) {
		this.useFlash = useFlash;
	}	

}
